;Ported to AutoIt by UEZ build 2016-09-30

#pragma compile(Icon, "c:\Program Files (x86)\AutoIt3\Icons\au3.ico")
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/so /pe /rm
#AutoIt3Wrapper_Run_After=del /f /q "%scriptdir%\%scriptfile%_stripped.au3"
#AutoIt3Wrapper_UseX64=y

#include <GUIConstantsEx.au3>
#include <WinAPIGdi.au3>
#include <WindowsConstants.au3>


AutoItSetOption("MustDeclareVars", 1)

Global Const $iW = 1200, $iH = 700, $sTitle = "GDI Animated Pythagoras Tree v2.5 / FPS: "
Global $hGUI, $iFPS = 0, $iShowFPS = 0, $bExit, $tRECT = DllStructCreate($tagRECT)
Global Const $hDLL_gdi32 = DllOpen("gdi32.dll"), $hDLL_user32 = DllOpen("user32.dll")
AutoItSetOption("GUIOnEventMode", 1)

PythagorasTreeRec()

AutoItSetOption("GUIOnEventMode", 0)


Func PythagorasTreeRec()
	$hGUI = GUICreate($sTitle & "0", $iW, $iH)
	Local Const $hDC = _WinAPI_GetDC($hGUI)
	Local Const $hBitmapGDI = _WinAPI_CreateCompatibleBitmap($hDC, $iW, $iH)
	Local Const $hGfxDC = _WinAPI_CreateCompatibleDC($hDC)
	Local Const $hObjOld = _WinAPI_SelectObject($hGfxDC, $hBitmapGDI)
	Local Const $hPen = _WinAPI_GetStockObject($DC_PEN), $hBrush = _WinAPI_GetStockObject($DC_BRUSH)
	Local Const $hPen_Old = _WinAPI_SelectObject($hGfxDC, $hPen), $hBrush_Old = _WinAPI_SelectObject($hGfxDC, $hBrush)
	_WinAPI_SetStretchBltMode($hDC, $WHITEONBLACK)
	GUISetState(@SW_SHOW, $hGUI)
	$bExit = False
	GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
	AdlibRegister("CalcFPS", 1000)

	Local $i = 0
	Do

		_WinAPI_BitBlt($hGfxDC, 0, 0, $iW, $iH, $hGfxDC, 0, 0, $WHITENESS)

		PythagorasRec($hGfxDC, 550, 700, 650, 700, 8)

		_WinAPI_BitBlt($hDC, 0, 0, $iW, $iH, $hGfxDC, 0, 0, $SRCCOPY)

		$iFPS += 1
		If $bExit Then ExitLoop
	Until Not Sleep(10)
	_WinAPI_SelectObject($hGfxDC, $hPen_Old)
	_WinAPI_DeleteObject($hPen)
	_WinAPI_SelectObject($hGfxDC, $hBrush_Old)
	_WinAPI_DeleteObject($hBrush)
	_WinAPI_SelectObject($hGfxDC, $hObjOld)
	_WinAPI_ReleaseDC($hGUI, $hDC)
	_WinAPI_DeleteDC($hGfxDC)
	_WinAPI_DeleteObject($hBitmapGDI)
	GUIDelete($hGUI)
	DllClose($hDLL_gdi32)
	DllClose($hDLL_user32)
EndFunc

Func _Exit()
	$bExit = True
EndFunc   ;==>_Exit_About

Func CalcFPS() ;display FPS
	$iShowFPS = $iFPS
	$iFPS = 0
	WinSetTitle($hGUI, "", $sTitle & $iShowFPS)
EndFunc   ;==>CalcFPS


Func PythagorasRec(ByRef Const $hDC, $iX1, $iY1, $iX2, $iY2, $iRecDepth)
	Local Const $iBGR1 = BitShift(255 - ($iRecDepth + 10) * 10, -8) + BitShift($iRecDepth * 20, 0) ;B = 0

	Local Static $i = 0
	Local Const $dx = $iX2 - $iX1, $dy = $iY1 - $iY2
	Local Const $iX3 = $iX2 - $dy, $iY3 = $iY2 - $dx
	Local Const $iX4 = $iX1 - $dy, $iY4 = $iY1 - $dx
	Local Const $iX5 = $iX4 + ($dx - $dy) / (2.5 - Cos(($iX4 + $i) / 400) / 1.5)
	Local Const $iY5 = $iY4 - ($dx + $dy) / (2.25 + Sin(($iX5 + $iY4 - $i) / 500))

	$i += 0.06666

	DllCall($hDLL_gdi32, "bool", "BeginPath", "handle", $hDC)
	DllCall($hDLL_gdi32, "bool", "MoveToEx", "handle", $hDC, "int", $iX1, "int", $iY1, "ptr", 0)
	DllCall($hDLL_gdi32, "bool", "LineTo", "handle", $hDC, "int", $iX2, "int", $iY2)
	DllCall($hDLL_gdi32, "bool", "LineTo", "handle", $hDC, "int", $iX3, "int", $iY3)
	DllCall($hDLL_gdi32, "bool", "LineTo", "handle", $hDC, "int", $iX4, "int", $iY4)
	DllCall($hDLL_gdi32, "bool", "LineTo", "handle", $hDC, "int", $iX1, "int", $iY1)
	DllCall($hDLL_gdi32, "bool", "EndPath", "handle", $hDC)

	;DllCall($hDLL_gdi32, "dword", "SetDCPenColor", "handle", $hDC, "dword", $iBGR1)
	DllCall($hDLL_gdi32, "dword", "SetDCBrushColor", "handle", $hDC, "dword", BitOR($iBGR1, 0x305090))
	DllCall($hDLL_gdi32, "bool", "FillPath", "handle", $hDC)
	;DllCall($hDLL_gdi32, "bool", "StrokeAndFillPath", "handle", $hDC)

	If $iRecDepth > 0 Then
		PythagorasRec($hDC, $iX4, $iY4, $iX5, $iY5, $iRecDepth - 1)
		PythagorasRec($hDC, $iX5, $iY5, $iX3, $iY3, $iRecDepth - 1)
	EndIf
EndFunc