;Ported to AutoIt by UEZ build 2016-10-02

#pragma compile(Icon, "c:\Program Files (x86)\AutoIt3\Icons\au3.ico")
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/so /pe /rm
#AutoIt3Wrapper_Run_After=del /f /q "%scriptdir%\%scriptfile%_stripped.au3"
#AutoIt3Wrapper_UseX64=y

#include <GUIConstantsEx.au3>
#include <GDIPlus.au3>
#include <WindowsConstants.au3>


AutoItSetOption("MustDeclareVars", 1)

Global Const $iW = 1200, $iH = 700, $sTitle = "GDI+ Animated Pythagoras Tree v2.5 / FPS: "
Global $hGUI, $iFPS = 0, $iShowFPS = 0, $bExit, $tRECT = DllStructCreate($tagRECT)

AutoItSetOption("GUIOnEventMode", 1)

PythagorasTreeRec()

AutoItSetOption("GUIOnEventMode", 0)

Func PythagorasTreeRec()
	_GDIPlus_Startup()
	$hGUI = GUICreate($sTitle & "0", $iW, $iH)
	Local Const $hDC = _WinAPI_GetDC($hGUI)
	Local Const $hBitmapGDI = _WinAPI_CreateCompatibleBitmap($hDC, $iW, $iH)
	Local Const $hGfxDC = _WinAPI_CreateCompatibleDC($hDC)
	Local Const $hObjOld = _WinAPI_SelectObject($hGfxDC, $hBitmapGDI)
	Local Const $hBrush = _GDIPlus_BrushCreateSolid()
	Local Const $hGfx = _GDIPlus_GraphicsCreateFromHDC($hGfxDC)
	_GDIPlus_GraphicsSetSmoothingMode($hGfx, 5)
	_GDIPlus_GraphicsSetPixelOffsetMode($hGfx, 4)
	GUISetState(@SW_SHOW, $hGUI)
	$bExit = False
	GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
	AdlibRegister("CalcFPS", 1000)

	Local $i = 0
	Do

		_WinAPI_BitBlt($hGfxDC, 0, 0, $iW, $iH, $hGfxDC, 0, 0, $WHITENESS)

		PythagorasRec($hGfx, $hBrush, 550, 700, 650, 700, 8)

		_WinAPI_BitBlt($hDC, 0, 0, $iW, $iH, $hGfxDC, 0, 0, $SRCCOPY)

		$iFPS += 1
		If $bExit Then ExitLoop
	Until Not Sleep(10)
	_GDIPlus_GraphicsDispose($hGfx)
	_WinAPI_SelectObject($hGfxDC, $hObjOld)
	_WinAPI_ReleaseDC($hGUI, $hDC)
	_WinAPI_DeleteDC($hGfxDC)
	_WinAPI_DeleteObject($hBitmapGDI)
	GUIDelete($hGUI)
	_GDIPlus_Shutdown()
EndFunc

Func _Exit()
	$bExit = True
EndFunc   ;==>_Exit_About

Func CalcFPS() ;display FPS
	$iShowFPS = $iFPS
	$iFPS = 0
	WinSetTitle($hGUI, "", $sTitle & $iShowFPS)
EndFunc   ;==>CalcFPS


Func PythagorasRec(ByRef Const $hGfx, ByRef Const $hBrush, $iX1, $iY1, $iX2, $iY2, $iRecDepth)
	Local Const $iARGB = 0xFF000000 + BitShift($iRecDepth * 20, -16) + BitShift(255 - ($iRecDepth + 10) * 10, -8)

	Local Static $i = 0
	Local Const $dx = $iX2 - $iX1, $dy = $iY1 - $iY2
	Local Const $iX3 = $iX2 - $dy, $iY3 = $iY2 - $dx
	Local Const $iX4 = $iX1 - $dy, $iY4 = $iY1 - $dx
	Local Const $iX5 = $iX4 + ($dx - $dy) / (2.5 - Cos(($iX4 + $i) / 400) / 1.5)
	Local Const $iY5 = $iY4 - ($dx + $dy) / (2.25 + Sin(($iX5 + $iY4 - $i) / 500))

	$i += 0.03333

	Local Const $hPath = DllCall($__g_hGDIPDll, "int", "GdipCreatePath", "int", 0, "handle*", 0)[2]
	DllCall($__g_hGDIPDll, "int", "GdipAddPathLine", "handle", $hPath, "float", $iX1, "float", $iY1, "float", $iX2, "float", $iY2)
	DllCall($__g_hGDIPDll, "int", "GdipAddPathLine", "handle", $hPath, "float", $iX2, "float", $iY2, "float", $iX3, "float", $iY3) ;line not needed
	DllCall($__g_hGDIPDll, "int", "GdipAddPathLine", "handle", $hPath, "float", $iX3, "float", $iY3, "float", $iX4, "float", $iY4)
	DllCall($__g_hGDIPDll, "int", "GdipAddPathLine", "handle", $hPath, "float", $iX4, "float", $iY4, "float", $iX1, "float", $iY1) ;line not needed
	DllCall($__g_hGDIPDll, "int", "GdipSetSolidFillColor", "handle", $hBrush, "dword", $iARGB)
	DllCall($__g_hGDIPDll, "int", "GdipFillPath", "handle", $hGfx, "handle", $hBrush, "handle", $hPath)
	DllCall($__g_hGDIPDll, "int", "GdipDeletePath", "handle", $hPath)

	If $iRecDepth > 0 Then
		PythagorasRec($hGfx, $hBrush, $iX4, $iY4, $iX5, $iY5, $iRecDepth - 1)
		PythagorasRec($hGfx, $hBrush, $iX5, $iY5, $iX3, $iY3, $iRecDepth - 1)
	EndIf
EndFunc