;Ported to AutoIt by UEZ build 2016-10-08

#pragma compile(Icon, "c:\Program Files (x86)\AutoIt3\Icons\au3.ico")
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/so /pe /rm
#AutoIt3Wrapper_Run_After=del /f /q "%scriptdir%\%scriptfile%_stripped.au3"
#AutoIt3Wrapper_UseX64=n

#include "OpenGL\OpenGL.au3"


AutoItSetOption("MustDeclareVars", 1)

Global Const $iW = 1200, $iH = 700, $sTitle = "OpenGL Animated Pythagoras Tree v2.5 / FPS: "
Global $iFPS = 0, $iShowFPS = 0, $bExit

PythagorasTreeRec()


Func PythagorasTreeRec()
	AdlibRegister("CalcFPS", 1000)
	glInit()
	gluInit()
	glfwInit()

	glfwOpenWindow($iW, $iH, 8, 8, 8, 0, 24, 0, $GLFW_WINDOW)
	glfwSetWindowTitle($sTitle)
	glfwSetWindowPos((@DesktopWidth - $iW) / 2, (@DesktopHeight - $iH) / 2 - 50)
	glViewport(0, 0, $iW, $iH)
	glMatrixMode($GL_PROJECTION)
	glLoadIdentity()
	glOrtho(0, $iW, $iH, 0, -128, 128)
	glMatrixMode($GL_MODELVIEW)
	glLoadIdentity()
	glShadeModel($GL_SMOOTH)
	glClearColor(0x60 / 0xFF, 0x60 / 0xFF, 0x60 / 0xFF, 1.0)
	glClearDepth(1.0)
	glEnable($GL_DEPTH_TEST)
	glDepthFunc($GL_LEQUAL)
	glHint($GL_PERSPECTIVE_CORRECTION_HINT, $GL_NICEST)

	While glfwGetWindowParam($GLFW_OPENED) And Not glfwGetKey($GLFW_KEY_ESC)
		glClear(BitOR($GL_COLOR_BUFFER_BIT, $GL_DEPTH_BUFFER_BIT))
		PythagorasRec(550, 700, 650, 700, 8)
		glfwSwapBuffers()
		;glFlush()
		$iFPS += 1
		Sleep(10)
	WEnd
	AdlibUnRegister("CalcFPS")
	glTerminate()
EndFunc


Func CalcFPS() ;display FPS
	$iShowFPS = $iFPS
	$iFPS = 0
	glfwSetWindowTitle($sTitle & $iShowFPS)
EndFunc   ;==>CalcFPS


Func PythagorasRec($iX1, $iY1, $iX2, $iY2, $iRecDepth)
	Local Static $iSpeed = -0xFFFF
	Local $iC1 = $iRecDepth * 16, $iC2 = 255 - ($iRecDepth + 12) * 10
	$iC1 = ($iC1 > 0xFF) ? 0xFF : $iC1
	$iC2 = ($iC2 > 0xFF) ? 0xFF : $iC2

	Local Const $dx = $iX2 - $iX1, $dy = $iY1 - $iY2
	Local Const $iX3 = $iX2 - $dy, $iY3 = $iY2 - $dx
	Local Const $iX4 = $iX1 - $dy, $iY4 = $iY1 - $dx
	Local Const $iX5 = $iX4 + ($dx - $dy) / (2.5 - Cos(($iX4 + $iSpeed) / 400) / 1.5)
	Local Const $iY5 = $iY4 - ($dx + $dy) / (2.25 + Sin(($iX5 + $iY4 - $iSpeed) / 500))


	glColor3ub($iC1, $iC2, 0)
	glBegin($GL_POLYGON)
		glVertex2f($iX1, $iY1)
		glVertex2f($iX2, $iY2)
		glVertex2f($iX3, $iY3)
		glVertex2f($iX4, $iY4)
		glVertex2f($iX1, $iY1)
	glEnd()

	$iSpeed += 0.05


	If $iRecDepth > 0 Then
		PythagorasRec($iX4, $iY4, $iX5, $iY5, $iRecDepth - 1)
		PythagorasRec($iX5, $iY5, $iX3, $iY3, $iRecDepth - 1)
	EndIf
EndFunc